#include "FenPrincipale.h"

FenPrincipale::FenPrincipale(QWidget *parent) : QMainWindow(parent)
{
	ui.setupUi(this); 

	m_pagedAccueil = new QUrl("http://www.google.com/");
	
	setWindowTitle("zNavigo");
	setWindowIcon(QIcon("znavigo_icones/web.png"));

	ui.actionPage_pr_c_dente->setIcon(QIcon("znavigo_icones/prec.png"));
	ui.mainToolBar->addAction(ui.actionPage_pr_c_dente);

	ui.actionPage_suivante->setIcon(QIcon("znavigo_icones/suiv.png"));
	ui.mainToolBar->addAction(ui.actionPage_suivante);

	ui.actionArr_ter_le_chargement->setIcon(QIcon("znavigo_icones/stop.png"));
	ui.mainToolBar->addAction(ui.actionArr_ter_le_chargement);

	ui.action_Actualiser->setIcon(QIcon("znavigo_icones/actu.png"));
	ui.mainToolBar->addAction(ui.action_Actualiser);

	ui.actionPage_d_a_cceuil->setIcon(QIcon("znavigo_icones/home.png"));
	ui.mainToolBar->addAction(ui.actionPage_d_a_cceuil);

	ui.mainToolBar->addSeparator();

	m_barreAdresse = new QLineEdit("", this);
	//m_barreAdresse->setPlaceholderText("Entrez l'adresse du site web içi...");
	ui.mainToolBar->addWidget(m_barreAdresse);
	m_actionAllerA = new QAction("A&ller à...");
	m_actionAllerA->setIcon(QIcon("znavigo_icones/go.png"));
	ui.mainToolBar->addAction(m_actionAllerA);

	connect(m_actionAllerA, SIGNAL(triggered()), this, SLOT(allerA()));
	connect(m_barreAdresse, SIGNAL(returnPressed()), this, SLOT(allerA()));
	
	QVBoxLayout* vLayout = new QVBoxLayout;

	//1: Création d'un QTabWidget
	m_onglets = new QTabWidget;
	m_onglets->setMovable(true);
	m_onglets->setTabsClosable(true);
	m_onglets->setTabShape(QTabWidget::Triangular);

	m_plusTab = new QPushButton("+");
	m_plusTab->setFixedSize(30, 20);
	m_onglets->setCornerWidget(m_plusTab);
	connect(m_plusTab, SIGNAL(clicked()), this, SLOT(on_actionNouvel_onglet_triggered()));

	//2&3: Création de l'onglet par défaut et son contenu:
	on_actionNouvel_onglet_triggered();

	m_onglets->setStyleSheet("QTabBar::tab{width:150px;}");
	m_onglets->setElideMode(Qt::ElideRight); //mettre les "..." si le titre est trop long


	this->setCentralWidget(m_onglets);

	m_chargement = new QProgressBar;
	m_chargement->setFixedHeight(20);
	m_chargement->setMaximumWidth(200);
	m_chargement->setValue(0); 
	QStatusBar* statusBar = new QStatusBar;
	statusBar->addPermanentWidget(m_chargement, 0); //to align right
	this->setStatusBar(statusBar);


	m_barreAdresse->setPlaceholderText(pageActuelle()->url().toString());
	connect(pageActuelle(), SIGNAL(loadProgress(int)), m_chargement, SLOT(setValue(int)));
	connect(m_onglets, SIGNAL(currentChanged(int)), this, SLOT(ongletChange()));
	connect(m_onglets, SIGNAL(tabCloseRequested(int)), this, SLOT(fermeLOnglet(int)));
}


inline QWebEngineView* FenPrincipale::pageActuelle()
{
	return ((QWebEngineView*)m_onglets->currentWidget());
}

void FenPrincipale::on_actionNouvel_onglet_triggered()
{
	QWebEngineView* view = new QWebEngineView;
	view->load(*m_pagedAccueil);
	int currentIndex = m_onglets->addTab(view, "New tab...");
	m_onglets->setCurrentIndex(currentIndex);
	connect(view, SIGNAL(loadFinished(bool)), this, SLOT(titrerLOnglet(bool)));
	m_count = m_onglets->count();
}

void FenPrincipale::titrerLOnglet(bool etat_OK)
{
	QWebEngineView* view = (QWebEngineView*) sender(); //obtenir un pointeur de l'émetteur

	int viewIndex = m_onglets->indexOf(view); //obtenir l'index du view émetteur

	if(etat_OK)
	{
		m_onglets->setTabText(viewIndex, view->title());
	}
	else
	{
		m_onglets->setTabText(viewIndex, "Loading...");
	}
}

void FenPrincipale::fermeLOnglet(int index)
{
	if (m_onglets->count() == 1)
	{
		pageActuelle()->load(*m_pagedAccueil);
	}
	else
	{
		m_onglets->removeTab(index);
	}
	m_count = m_onglets->count();
}

void FenPrincipale::on_actionFermer_onglet_triggered()
{
	fermeLOnglet(m_onglets->currentIndex());
}

void FenPrincipale::on_actionPage_pr_c_dente_triggered()
{
	pageActuelle()->back();
}

void FenPrincipale::on_actionPage_suivante_triggered()
{
	pageActuelle()->forward();
}

void FenPrincipale::on_action_Actualiser_triggered()
{
	pageActuelle()->reload();
}

void FenPrincipale::on_actionArr_ter_le_chargement_triggered()
{
	pageActuelle()->stop();
}

void FenPrincipale::on_actionPage_d_a_cceuil_triggered()
{
	pageActuelle()->load(*m_pagedAccueil);
}

void FenPrincipale::on_action_Fermer_triggered()
{
	qApp->quit();
}

void FenPrincipale::on_action_A_propos_triggered()
{
	QMessageBox::information(this, "A propos...", "zNavigo version 1.0 2019");
}

void FenPrincipale::on_actionA_porpos_de_Qt_triggered()
{
	QMessageBox::information(this, "A propos de Qt...", "Ce programme utilise la version 5.12.0 de Qt");
}

void FenPrincipale::allerA()
{
	QString adresse = "";
	adresse = m_barreAdresse->text();

	if (!(adresse.startsWith("http://") || adresse.startsWith("https://")))
	{
		adresse.prepend("https://");
	}

	m_barreAdresse->setText(adresse);
	pageActuelle()->load(adresse);
}

void FenPrincipale::ongletChange()
{
	disconnect(m_chargement, SLOT(setValue(int)));
	connect(pageActuelle(), SIGNAL(loadProgress(int)), m_chargement, SLOT(setValue(int)));
	m_barreAdresse->setText(pageActuelle()->url().toString());
}
